import { ApolloServer } from 'apollo-server-express'
export const initializeServer = async (models, schema) => {
  const server = new ApolloServer({
    schema,
    context: async (ctx) => ({
      models,
      req: ctx.req,
    }),
  })

  const corsOptions = {
    credentials: true,
    origin: true,
  }

  const app = express()
  app.use(express.json())
  app.use(cors(corsOptions))
  app.use(bodyParser.urlencoded({ extended: false }))
  app.use(bodyParser.json())

  await server.start()
  server.applyMiddleware({ app, cors: false })

  const httpServer = http.createServer(app)

  models.sequelize.sync({}).then(() => {
    httpServer.listen(process.env.PORT, () => {
      console.log(
        `🚀 Server ready at http://localhost:${process.env.PORT}${server.graphqlPath}`
      )
    })
  })
}
